function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import PropTypes from 'prop-types';
import React, { useState, useEffect, useReducer } from 'react';
import Context from './Context';
import useMediaQuery from '@material-ui/core/useMediaQuery';
import { setMiniMode as _setMiniMode, setMenuOpen as _setMenuOpen, setMobileMenuOpen as _setMobileMenuOpen, setMiniSwitchVisibility as _setMiniSwitchVisibility } from './store/actions';
import reducer from './store/reducer';

var Provider = function Provider(_ref) {
  var appConfig = _ref.appConfig,
      children = _ref.children,
      _ref$persistKey = _ref.persistKey,
      persistKey = _ref$persistKey === void 0 ? 'menu' : _ref$persistKey;

  var _ref2 = appConfig || {},
      menu = _ref2.menu;

  var initialMiniMode = menu.initialMiniMode,
      initialMenuOpen = menu.initialMenuOpen,
      initialMobileMenuOpen = menu.initialMobileMenuOpen,
      initialMiniSwitchVisibility = menu.initialMiniSwitchVisibility,
      useWindowWatcher = menu.useWindowWatcher;
  var savedState = JSON.parse(localStorage.getItem(persistKey));

  var _useReducer = useReducer(reducer, _extends({
    miniMode: initialMiniMode,
    menuOpen: initialMenuOpen,
    mobileMenuOpen: initialMobileMenuOpen,
    miniSwitchVisibility: initialMiniSwitchVisibility
  }, savedState)),
      menuStore = _useReducer[0],
      dispatch = _useReducer[1];

  var props = {
    //setters
    setMiniMode: function setMiniMode(payload) {
      return dispatch(_setMiniMode(payload));
    },
    setMenuOpen: function setMenuOpen(payload) {
      return dispatch(_setMenuOpen(payload));
    },
    setMobileMenuOpen: function setMobileMenuOpen(payload) {
      return dispatch(_setMobileMenuOpen(payload));
    },
    setMiniSwitchVisibility: function setMiniSwitchVisibility(payload) {
      return dispatch(_setMiniSwitchVisibility(payload));
    },
    //getters
    isMiniMode: menuStore.miniMode,
    isMenuOpen: menuStore.menuOpen,
    isMobileMenuOpen: menuStore.mobileMenuOpen,
    isMiniSwitchVisibility: menuStore.miniSwitchVisibility
  };

  var _useState = useState(false),
      isAuthMenuOpen = _useState[0],
      setAuthMenuOpen = _useState[1];

  var isDesktop = useMediaQuery('(min-width:600px)');
  useEffect(function () {
    try {
      localStorage.setItem(persistKey, JSON.stringify(menuStore));
    } catch (error) {
      console.warn(error);
    }
  }, [menuStore, persistKey]);
  useEffect(function () {
    if (useWindowWatcher) {
      if (!isDesktop) {
        props.setMenuOpen(false);
        props.setMiniMode(false);
      }
    }
  }, [isDesktop, props, useWindowWatcher]);
  return /*#__PURE__*/React.createElement(Context.Provider, {
    value: _extends({
      isDesktop,
      isAuthMenuOpen,
      setAuthMenuOpen
    }, props)
  }, children);
};

Provider.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.any
} : {};
export default Provider;