"use strict";

exports.__esModule = true;
exports.default = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _Context = _interopRequireDefault(require("./Context"));

var _useMediaQuery = _interopRequireDefault(require("@material-ui/core/useMediaQuery"));

var _actions = require("./store/actions");

var _reducer = _interopRequireDefault(require("./store/reducer"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var Provider = function Provider(_ref) {
  var appConfig = _ref.appConfig,
      children = _ref.children,
      _ref$persistKey = _ref.persistKey,
      persistKey = _ref$persistKey === void 0 ? 'menu' : _ref$persistKey;

  var _ref2 = appConfig || {},
      menu = _ref2.menu;

  var initialMiniMode = menu.initialMiniMode,
      initialMenuOpen = menu.initialMenuOpen,
      initialMobileMenuOpen = menu.initialMobileMenuOpen,
      initialMiniSwitchVisibility = menu.initialMiniSwitchVisibility,
      useWindowWatcher = menu.useWindowWatcher;
  var savedState = JSON.parse(localStorage.getItem(persistKey));

  var _useReducer = (0, _react.useReducer)(_reducer.default, _extends({
    miniMode: initialMiniMode,
    menuOpen: initialMenuOpen,
    mobileMenuOpen: initialMobileMenuOpen,
    miniSwitchVisibility: initialMiniSwitchVisibility
  }, savedState)),
      menuStore = _useReducer[0],
      dispatch = _useReducer[1];

  var props = {
    //setters
    setMiniMode: function setMiniMode(payload) {
      return dispatch((0, _actions.setMiniMode)(payload));
    },
    setMenuOpen: function setMenuOpen(payload) {
      return dispatch((0, _actions.setMenuOpen)(payload));
    },
    setMobileMenuOpen: function setMobileMenuOpen(payload) {
      return dispatch((0, _actions.setMobileMenuOpen)(payload));
    },
    setMiniSwitchVisibility: function setMiniSwitchVisibility(payload) {
      return dispatch((0, _actions.setMiniSwitchVisibility)(payload));
    },
    //getters
    isMiniMode: menuStore.miniMode,
    isMenuOpen: menuStore.menuOpen,
    isMobileMenuOpen: menuStore.mobileMenuOpen,
    isMiniSwitchVisibility: menuStore.miniSwitchVisibility
  };

  var _useState = (0, _react.useState)(false),
      isAuthMenuOpen = _useState[0],
      setAuthMenuOpen = _useState[1];

  var isDesktop = (0, _useMediaQuery.default)('(min-width:600px)');
  (0, _react.useEffect)(function () {
    try {
      localStorage.setItem(persistKey, JSON.stringify(menuStore));
    } catch (error) {
      console.warn(error);
    }
  }, [menuStore, persistKey]);
  (0, _react.useEffect)(function () {
    if (useWindowWatcher) {
      if (!isDesktop) {
        props.setMenuOpen(false);
        props.setMiniMode(false);
      }
    }
  }, [isDesktop, props, useWindowWatcher]);
  return /*#__PURE__*/_react.default.createElement(_Context.default.Provider, {
    value: _extends({
      isDesktop,
      isAuthMenuOpen,
      setAuthMenuOpen
    }, props)
  }, children);
};

Provider.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes.default.any
} : {};
var _default = Provider;
exports.default = _default;
module.exports = exports.default;