"use strict";

exports.__esModule = true;
exports.default = reducer;

var types = _interopRequireWildcard(require("./types"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function reducer(state, action) {
  if (state === void 0) {
    state = {};
  }

  var type = action.type,
      payload = action.payload;

  switch (type) {
    case types.SET_MINI_MODE:
      return _extends(_extends({}, state), {}, {
        miniMode: payload
      });

    case types.SET_MENU_OPEN:
      return _extends(_extends({}, state), {}, {
        menuOpen: payload
      });

    case types.SET_MOBILE_MENU_OPEN:
      return _extends(_extends({}, state), {}, {
        mobileMenuOpen: payload
      });

    case types.SET_MINI_SWITCH_VISIBILITY:
      return _extends(_extends({}, state), {}, {
        miniSwitchVisibility: payload
      });

    default:
      return state;
  }
}

module.exports = exports.default;